]> git.proxmox.com Git - mirror_ubuntu-artful-kernel.git/blob - scripts/kconfig/Makefile
Merge branch 'fix/arizona' of git://git.kernel.org/pub/scm/linux/kernel/git/broonie...
[mirror_ubuntu-artful-kernel.git] / scripts / kconfig / Makefile
1 # ===========================================================================
2 # Kernel configuration targets
3 # These targets are used from top-level makefile
4
5 PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
6 localmodconfig localyesconfig
7
8 ifdef KBUILD_KCONFIG
9 Kconfig := $(KBUILD_KCONFIG)
10 else
11 Kconfig := Kconfig
12 endif
13
14 ifeq ($(quiet),silent_)
15 silent := -s
16 endif
17
18 # We need this, in case the user has it in its environment
19 unexport CONFIG_
20
21 xconfig: $(obj)/qconf
22 $< $(silent) $(Kconfig)
23
24 gconfig: $(obj)/gconf
25 $< $(silent) $(Kconfig)
26
27 menuconfig: $(obj)/mconf
28 $< $(silent) $(Kconfig)
29
30 config: $(obj)/conf
31 $< $(silent) --oldaskconfig $(Kconfig)
32
33 nconfig: $(obj)/nconf
34 $< $(silent) $(Kconfig)
35
36 silentoldconfig: $(obj)/conf
37 $(Q)mkdir -p include/config include/generated
38 $< $(silent) --$@ $(Kconfig)
39
40 localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
41 $(Q)mkdir -p include/config include/generated
42 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
43 $(Q)if [ -f .config ]; then \
44 cmp -s .tmp.config .config || \
45 (mv -f .config .config.old.1; \
46 mv -f .tmp.config .config; \
47 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
48 mv -f .config.old.1 .config.old) \
49 else \
50 mv -f .tmp.config .config; \
51 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
52 fi
53 $(Q)rm -f .tmp.config
54
55 # Create new linux.pot file
56 # Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
57 update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
58 $(Q)$(kecho) " GEN config.pot"
59 $(Q)xgettext --default-domain=linux \
60 --add-comments --keyword=_ --keyword=N_ \
61 --from-code=UTF-8 \
62 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
63 --directory=$(srctree) --directory=$(objtree) \
64 --output $(obj)/config.pot
65 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
66 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
67 $(srctree)/arch/*/um/Kconfig`; \
68 do \
69 $(kecho) " GEN $$i"; \
70 $(obj)/kxgettext $$i \
71 >> $(obj)/config.pot; \
72 done )
73 $(Q)$(kecho) " GEN linux.pot"
74 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
75 --output $(obj)/linux.pot
76 $(Q)rm -f $(obj)/config.pot
77
78 # These targets map 1:1 to the commandline options of 'conf'
79 simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
80 alldefconfig randconfig listnewconfig olddefconfig
81 PHONY += $(simple-targets)
82
83 $(simple-targets): $(obj)/conf
84 $< $(silent) --$@ $(Kconfig)
85
86 PHONY += oldnoconfig savedefconfig defconfig
87
88 # oldnoconfig is an alias of olddefconfig, because people already are dependent
89 # on its behavior (sets new symbols to their default value but not 'n') with the
90 # counter-intuitive name.
91 oldnoconfig: olddefconfig
92
93 savedefconfig: $(obj)/conf
94 $< $(silent) --$@=defconfig $(Kconfig)
95
96 defconfig: $(obj)/conf
97 ifeq ($(KBUILD_DEFCONFIG),)
98 $< $(silent) --defconfig $(Kconfig)
99 else ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
100 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
102 else
103 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
104 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
105 endif
106
107 %_defconfig: $(obj)/conf
108 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
109
110 configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
111
112 %.config: $(obj)/conf
113 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
114 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
115 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
116
117 PHONY += kvmconfig
118 kvmconfig: kvm_guest.config
119 @:
120
121 PHONY += xenconfig
122 xenconfig: xen.config
123 @:
124
125 PHONY += tinyconfig
126 tinyconfig:
127 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
128
129 # Help text used by make help
130 help:
131 @echo ' config - Update current config utilising a line-oriented program'
132 @echo ' nconfig - Update current config utilising a ncurses menu based'
133 @echo ' program'
134 @echo ' menuconfig - Update current config utilising a menu based program'
135 @echo ' xconfig - Update current config utilising a Qt based front-end'
136 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
137 @echo ' oldconfig - Update current config utilising a provided .config as base'
138 @echo ' localmodconfig - Update current config disabling modules not loaded'
139 @echo ' localyesconfig - Update current config converting local mods to core'
140 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
141 @echo ' defconfig - New config with default from ARCH supplied defconfig'
142 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
143 @echo ' allnoconfig - New config where all options are answered with no'
144 @echo ' allyesconfig - New config where all options are accepted with yes'
145 @echo ' allmodconfig - New config selecting modules when possible'
146 @echo ' alldefconfig - New config with all symbols set to default'
147 @echo ' randconfig - New config with random answer to all options'
148 @echo ' listnewconfig - List new options'
149 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their'
150 @echo ' default value'
151 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
152 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
153 @echo ' tinyconfig - Configure the tiniest possible kernel'
154
155 # lxdialog stuff
156 check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
157
158 # Use recursively expanded variables so we do not call gcc unless
159 # we really need to do so. (Do not call gcc as part of make mrproper)
160 HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
161 -DLOCALE
162
163 # ===========================================================================
164 # Shared Makefile for the various kconfig executables:
165 # conf: Used for defconfig, oldconfig and related targets
166 # nconf: Used for the nconfig target.
167 # Utilizes ncurses
168 # mconf: Used for the menuconfig target
169 # Utilizes the lxdialog package
170 # qconf: Used for the xconfig target
171 # Based on Qt which needs to be installed to compile it
172 # gconf: Used for the gconfig target
173 # Based on GTK+ which needs to be installed to compile it
174 # object files used by all kconfig flavours
175
176 lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
177 lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
178
179 conf-objs := conf.o zconf.tab.o
180 mconf-objs := mconf.o zconf.tab.o $(lxdialog)
181 nconf-objs := nconf.o zconf.tab.o nconf.gui.o
182 kxgettext-objs := kxgettext.o zconf.tab.o
183 qconf-cxxobjs := qconf.o
184 qconf-objs := zconf.tab.o
185 gconf-objs := gconf.o zconf.tab.o
186
187 hostprogs-y := conf nconf mconf kxgettext qconf gconf
188
189 clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
190 clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
191 clean-files += config.pot linux.pot
192
193 # Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
194 PHONY += $(obj)/dochecklxdialog
195 $(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
196 $(obj)/dochecklxdialog:
197 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
198
199 always := dochecklxdialog
200
201 # Add environment specific flags
202 HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
203
204 # generated files seem to need this to find local include files
205 HOSTCFLAGS_zconf.lex.o := -I$(src)
206 HOSTCFLAGS_zconf.tab.o := -I$(src)
207
208 LEX_PREFIX_zconf := zconf
209 YACC_PREFIX_zconf := zconf
210
211 HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
212 HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
213
214 HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
215 HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
216 -Wno-missing-prototypes
217
218 HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
219
220 HOSTLOADLIBES_nconf = $(shell \
221 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
222 || pkg-config --libs menu panel ncurses 2>/dev/null \
223 || echo "-lmenu -lpanel -lncurses" )
224 $(obj)/qconf.o: $(obj)/.tmp_qtcheck
225
226 ifeq ($(MAKECMDGOALS),xconfig)
227 $(obj)/.tmp_qtcheck: $(src)/Makefile
228 -include $(obj)/.tmp_qtcheck
229
230 # Qt needs some extra effort...
231 $(obj)/.tmp_qtcheck:
232 @set -e; $(kecho) " CHECK qt"; \
233 if pkg-config --exists Qt5Core; then \
234 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
235 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
236 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
237 elif pkg-config --exists QtCore; then \
238 cflags=`pkg-config --cflags QtCore QtGui`; \
239 libs=`pkg-config --libs QtCore QtGui`; \
240 moc=`pkg-config --variable=moc_location QtCore`; \
241 else \
242 echo >&2 "*"; \
243 echo >&2 "* Could not find Qt via pkg-config."; \
244 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
245 echo >&2 "*"; \
246 exit 1; \
247 fi; \
248 echo "KC_QT_CFLAGS=$$cflags" > $@; \
249 echo "KC_QT_LIBS=$$libs" >> $@; \
250 echo "KC_QT_MOC=$$moc" >> $@
251 endif
252
253 $(obj)/gconf.o: $(obj)/.tmp_gtkcheck
254
255 ifeq ($(MAKECMDGOALS),gconfig)
256 -include $(obj)/.tmp_gtkcheck
257
258 # GTK+ needs some extra effort, too...
259 $(obj)/.tmp_gtkcheck:
260 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
261 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
262 touch $@; \
263 else \
264 echo >&2 "*"; \
265 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
266 echo >&2 "*"; \
267 false; \
268 fi \
269 else \
270 echo >&2 "*"; \
271 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
272 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
273 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
274 echo >&2 "*"; \
275 false; \
276 fi
277 endif
278
279 $(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
280
281 $(obj)/qconf.o: $(obj)/qconf.moc
282
283 quiet_cmd_moc = MOC $@
284 cmd_moc = $(KC_QT_MOC) -i $< -o $@
285
286 $(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
287 $(call cmd,moc)
288
289 # Extract gconf menu items for i18n support
290 $(obj)/gconf.glade.h: $(obj)/gconf.glade
291 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
292 $(obj)/gconf.glade